Update an Estimate Item
Edit an existing estimate item in your ConstructionOnline company account
https://api.constructiononline.com/api/v2/EstimateItems?itemID={itemID}
This endpoint allows users to edit an existing estimate item within an estimate in their ConstructionOnline company account. To update an estimate item, users must know the unique numerical ID assigned to the item. The estimate item's ID is stored in the property 'ID'. Only the properties specified in the request body will be updated; the other properties will remain as is. This endpoint will also not update any locked fields within the ConstructionOnline estimate.
Requests
itemID: integer
- Unique identifier for the estimate item.
Item Info: JSON
- Updated properties for the item.
- Allowed properties in itemInfo: NAME, DESCRIPTION, COST_CODE, COST_CODE_ID, TRAFFIC_COLOR, BID_NOTES, NOTES_TEAMLINK, NOTES_BID, FIELD_NOTES, NOTES_CLIENTLINK, NOTES_FIELD, GENERAL_NOTES, NOTES_GENERAL, CLASSIFICATION, STATUS, UNIT, QTY, RATE_QTY, UNIT_COST, RATE, FIVE_COLUMN_MATERIAL, FIVE_COLUMN_LABOR, FIVE_COLUMN_EQUIPMENT, FIVE_COLUMN_SUB, FIVE_COLUMN_OTHER, LINE_ITEM_MARKUP, LINE_ITEM_MARKUP_TYPE, ADJUSTMENT, ACTUAL, COMMITTED_COSTS, INVOICED_AMOUNTS
Individual properties for update should be entered as JSON key-value pairs, as seen below:
{
"QTY": 135,
"GENERAL_NOTES": "Revised to 135 CY after re-measure"
}
Example requests in cURL, C#, Python, and JavaScript can be found below:
cURL
# replace {email} with the email address for your ConstructionOnline account
# {password} with your ConstructionOnline password
# {apikey} with your provided API key
# {itemID} with the estimate item's ID
curl -X PUT https://api.constructiononline.com/api/v2/EstimateItems?itemID={itemID} -u {email}:{password} -H 'APIKey:{apikey}'
C#
/* replace {username} with the email address for your ConstructionOnline account
{password} with your ConstructionOnline password
{apikey} with your provided API key
{itemID} with the estimate item's ID */
public string MakeRequest(string endpoint, string payload) {
string username = {username};
string password = {password};
string apiKey = {apikey};
string response = "";
var handler = new HttpClientHandler() { AutomaticDecompression = System.Net.DecompressionMethods.GZip };
using (HttpClient client = new HttpClient(handler)) {
client.BaseAddress = new Uri("http://api.constructiononline.com");
client.DefaultRequestHeaders.Accept.Clear();
client.DefaultRequestHeaders.Accept.Add(new MediaTypeWithQualityHeaderValue("application/json"));
client.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", System.Convert.ToBase64String(System.Text.Encoding.GetEncoding("ISO-8859-1").GetBytes(username + ":" + password)));
client.DefaultRequestHeaders.Add("APIKey", apiKey);
client.DefaultRequestHeaders.Add("Accept-Encoding", "gzip");
HttpContent content = new StringContent(payload, System.Text.Encoding.UTF32, "application/json");
response = client.PutAsync(endpoint, content).Result.ToString();
}
return response;
}
MakeRequest("api/v2/EstimateItems?itemID={itemID}");
Python
#replace {username} with the email address for your ConstructionOnline account
#{password} with your ConstructionOnline password
#{apikey} with your provided API key
#{itemID} with the estimate item's ID
import base64, requests, json
#Global Variables
apikey = {apikey}
username = {username}
password = {password}
#Functions
def makeRequest(endpoint, payload):
url = "https://api.constructiononline.com/" + endpoint
userPass = username + ":" + password
headers = {
"APIKey": apikey,
"Accept-Encoding": "gzip, deflate, br",
"Authorization": "Basic " + base64.b64encode(userPass.encode()).decode(),
}
response = requests.request("PUT", url, headers=headers, data=payload)
return json.dumps(json.loads(response.text), indent=2)
#Main Program
print(makeRequest("api/v2/EstimateItems?itemID={itemID}"))
JavaScript
/* replace {username} with the email address for your ConstructionOnline account
{password} with your ConstructionOnline password
{apikey} with your provided API key
{itemID} with the estimate item's ID */
username = '{username}';
password = '{password}';
apikey = '{apikey}';
function makeRequest(endpoint, payload) {
auth = btoa('${username}:${password}');
var myHeaders = new Headers();
myHeaders.append("APIKey", apikey);
myHeaders.append("Accept-Encoding", "gzip, deflate, br");
myHeaders.append("Authorization", "Basic ${auth}");
var requestOptions = {
method: 'PUT',
body: '',
headers: myHeaders,
redirect: 'follow'
};
fetch("https://api.constructiononline.com/" + endpoint, requestOptions)
.then(response => response.text())
.then(result => console.log(result))
.catch(error => console.log('error', error));
return response;
};
makeRequest("api/v2/EstimateItems?itemID={itemID}");
Responses
200: Success
A successful request will return a 200 response with a record of the edited estimate item in the body.
A sample response and property definitions can be found here.
404: Error
The server was not able to locate the resource specified in the request. The ID may have been entered incorrectly or an estimate item with the entered ID does not exist.
429: Error
The user has surpassed the request rate limit for the hour, day, week, or month.
500: Error
There was an internal server error and the server was unable to complete the request.
Last updated: Sep 22, 2026